<template>
  <div class="d-flex justify-center">
    <v-sheet max-width="800px">
      <h4 class="mb-3">
        Archive Details
      </h4>

      <v-row>
        <v-col cols="12">
          <v-text-field
            v-model="createForm.title"
            label="Title*"
            outlined
            dense
            required
            hide-details
          />
        </v-col>

        <v-col cols="12">
          <v-menu
            v-model="datePickerStatus"
            :close-on-content-click="false"
            max-width="290"
          >
            <template #activator="{ on, attrs }">
              <v-text-field
                :value="computedDateFormattedMomentjs"
                clearable
                label="Published Date"
                readonly
                dense
                v-bind="attrs"
                outlined
                hide-details
                v-on="on"
                @click:clear="createForm.published_date = null"
              />
            </template>

            <v-date-picker
              v-model="createForm.published_date"
              dense
              @change="datePickerStatus = false"
            />
          </v-menu>
        </v-col>

        <v-col cols="12">
          <v-file-input
            v-model="createForm.note"
            show-size
            counter
            dense
            hide-details
            outlined
            label="Abstract*"
          />
        </v-col>

        <v-col cols="12">
          <v-file-input
            v-model="createForm.file"
            show-size
            counter
            dense
            hide-details
            outlined
            label="File*"
          />
        </v-col>
      </v-row>

      <v-divider class="my-5" />

      <h4 class="mb-3">
        Keyword Details
      </h4>

      <v-row>
        <v-col cols="12">
          <v-text-field
            label="Keyword*"
            placeholder="Press `enter` to add keyword"
            outlined
            required
            dense
            hide-details
            @keyup.enter="handleEnterTag"
          />

          <v-chip
            v-for="(currItem, itemKey) in createForm.tags"
            :key="itemKey"
            class="my-1 mr-1"
            close
            @click:close="createForm.tags.splice(itemKey, 1)"
          >
            {{ currItem }}
          </v-chip>
        </v-col>
      </v-row>

      <v-divider class="my-5" />

      <h4 class="mb-3">
        Author Details
      </h4>

      <v-row>
        <v-col cols="12">
          <v-text-field
            v-model="createForm.author.name"
            label="Author*"
            placeholder="Author*"
            outlined
            required
            dense
            hide-details
          />
        </v-col>

        <v-col cols="12">
          <v-text-field
            v-model="createForm.author.semester"
            label="Semester*"
            placeholder="Semester*"
            outlined
            required
            dense
            hide-details
          />
        </v-col>

        <v-col cols="6">
          <v-text-field
            v-model="createForm.author.year"
            label="Year*"
            placeholder="Year*"
            outlined
            required
            dense
            hide-details
          />
        </v-col>

        <v-col cols="6">
          <v-text-field
            v-model="createForm.author.section"
            label="Section*"
            placeholder="Section*"
            outlined
            required
            dense
            hide-details
          />
        </v-col>

        <v-col cols="12">
          <v-text-field
            v-model="createForm.author.adviser"
            label="Adviser*"
            placeholder="Adviser*"
            outlined
            required
            dense
            hide-details
          />
        </v-col>

        <v-col cols="12">
          <v-text-field
            label="Panelists*"
            placeholder="Press `enter` to add panelist"
            outlined
            required
            dense
            hide-details
            @keyup.enter="handleClickCreatePanelistsKeyup"
          />

          <v-chip
            v-for="(currAuthor, authorKey) in createForm.author.panelists"
            :key="authorKey"
            class="my-1 mr-1"
            close
            @click:close="handleClickCreateRemovePanelist(authorKey)"
          >
            {{ currAuthor }}
          </v-chip>
        </v-col>

        <v-col
          cols="12"
          class="d-flex justify-end"
        >
          <v-btn
            small
            color="primary"
          >
            Add Author
          </v-btn>
        </v-col>
      </v-row>
    </v-sheet>
  </div>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

import moment from 'moment'

export default {
  components: {
    // VFooter
  },

  data: () => ({
    filterList: ['All', 'Author', 'Year', 'Title', 'Tag'],

    datePickerStatus: false,

    createForm: {
      title: '',
      note: null,
      published_date: moment().format('YYYY-MM-DD HH:mm:ss'),
      tags: [],
      authors: [],
      author: {},
      file: null
    },

    searchPanelExpansion: [0, 1, 2, 3],

    dataStatus: {
      sidebarAuthor: { loading: true },
      sidebarPublishDates: { loading: true },
      sidebarSubjects: { loading: true },
      sidebarTags: { loading: true },
      archives: { loading: true }
    }
  }),

  computed: {
    ...mapState('authors', {
      publicArchiveAuthors: 'publicArchiveAuthors'
    }),

    ...mapState('tags', {
      publicArchiveTags: 'publicArchiveTags'
    }),

    ...mapState('archives', {
      publicArchivePublishDates: 'publicArchivePublishDates',
      archivesList: 'archives'
    }),

    computedDateFormattedMomentjs () {
      const date = this.modals.createArchive.data.published_date
      return date ? moment(date).format('dddd, MMMM Do YYYY') : ''
    }
  },

  watch: {
    $route: {
      async handler (data) {
        await this.bootstrap({ ...data.query })
      },

      immediate: true
    }
  },

  async created () {
    await this.bootstrapSidebar()
  },

  methods: {
    ...mapActions('authors', {
      getPublicArchiveAuthorsList: 'getPublicArchiveAuthorsList'
    }),

    ...mapActions('tags', {
      getPublicArchiveTagsList: 'getPublicArchiveTagsList'
    }),

    ...mapActions('archives', {
      getPublicArchivePublishDatesList: 'getPublicArchivePublishDatesList',
      getArchivesList: 'getArchivesList'
    }),

    handleSidebarSearch (filterBy, q) {
      const query = this.$route.query
      const newQuery = { filterBy, q }
      this.$router.push({ query: { ...query, ...newQuery } })
    },

    async bootstrap (query) {
      this.dataStatus.archives.loading = true
      await this.getArchivesList({ ...this.$route.query, ...query })
      this.dataStatus.archives.loading = false
    },

    async bootstrapSidebar () {
      this.dataStatus.sidebarAuthor.loading = true
      this.dataStatus.sidebarSubjects.loading = true
      this.dataStatus.sidebarTags.loading = true
      this.dataStatus.sidebarPublishDates.loading = true

      await Promise.all([
        // this.getPublicArchiveAuthorsList(),
        this.getPublicArchiveTagsList(),
        this.getPublicArchivePublishDatesList()
      ])

      this.dataStatus.sidebarAuthor.loading = false
      this.dataStatus.sidebarSubjects.loading = false
      this.dataStatus.sidebarTags.loading = false
      this.dataStatus.sidebarPublishDates.loading = false
    }
  }
}
</script>
